"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
function getCryptoUSDValue(sCurrencyCode) {
    return __awaiter(this, void 0, void 0, function () {
        var sAPIURL, apiResponse, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    sAPIURL = "https://api.coinmarketcap.com/v1/ticker/" + sCurrencyCode + "/";
                    return [4 /*yield*/, axios_1.default.get(sAPIURL).then(function (data) {
                            if (data.data && data.data.length > 0 && data.data[0].price_usd) {
                                // has returned the data we expected
                                return Number(data.data[0].price_usd);
                            }
                            return null;
                        })];
                case 1:
                    apiResponse = _a.sent();
                    return [2 /*return*/, apiResponse];
                case 2:
                    err_1 = _a.sent();
                    return [2 /*return*/, null];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.getCryptoUSDValue = getCryptoUSDValue;
function getMultipleCryptoUSDValue(saCurrencyCodes) {
    return __awaiter(this, void 0, void 0, function () {
        var sAPIURL, data, currencies, oReturnCurrencies, iIndex, _a, id, price_usd, err_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    sAPIURL = "https://api.coinmarketcap.com/v1/ticker/?limit=0";
                    return [4 /*yield*/, axios_1.default.get(sAPIURL)
                        // parse out currencies we're interested in
                    ];
                case 1:
                    data = _b.sent();
                    // parse out currencies we're interested in
                    if (data.data && data.data.length > 0 && data.data[0].price_usd) {
                        currencies = data.data;
                        oReturnCurrencies = {};
                        for (iIndex = 0; iIndex < currencies.length; iIndex++) {
                            if (saCurrencyCodes.indexOf(currencies[iIndex].id) > -1) {
                                _a = currencies[iIndex], id = _a.id, price_usd = _a.price_usd;
                                oReturnCurrencies[id] = {
                                    usdValue: Number(price_usd)
                                };
                            }
                        }
                        // has returned the data we expected
                        return [2 /*return*/, oReturnCurrencies];
                    }
                    return [2 /*return*/, null];
                case 2:
                    err_2 = _b.sent();
                    return [2 /*return*/, null];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.getMultipleCryptoUSDValue = getMultipleCryptoUSDValue;
function getAllCryptoValues() {
    return __awaiter(this, void 0, void 0, function () {
        var sAPIURL, data, aReturnCurrencies, currencies, iIndex, _a, id, name, symbol, twenty_four_hour_volume, volume_usd_24h, rank, price_usd, price_btc, market_cap_usd, available_supply, total_supply, max_supply, percent_change_1h, percent_change_24h, percent_change_7d, last_updated, oParsingCurrency, err_3;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    sAPIURL = "https://api.coinmarketcap.com/v1/ticker/?limit=0";
                    return [4 /*yield*/, axios_1.default.get(sAPIURL)];
                case 1:
                    data = _b.sent();
                    aReturnCurrencies = [];
                    if (data.data && data.data.length > 0) {
                        currencies = data.data;
                        for (iIndex = 0; iIndex < currencies.length; iIndex++) {
                            _a = currencies[iIndex], id = _a.id, name = _a.name, symbol = _a.symbol;
                            twenty_four_hour_volume = '24h_volume_usd';
                            volume_usd_24h = Number(currencies[iIndex][twenty_four_hour_volume]);
                            rank = Number(currencies[iIndex].rank);
                            price_usd = Number(currencies[iIndex].price_usd);
                            price_btc = Number(currencies[iIndex].price_btc);
                            market_cap_usd = Number(currencies[iIndex].market_cap_usd);
                            available_supply = Number(currencies[iIndex].available_supply);
                            total_supply = Number(currencies[iIndex].total_supply);
                            max_supply = Number(currencies[iIndex].max_supply);
                            percent_change_1h = Number(currencies[iIndex].percent_change_1h);
                            percent_change_24h = Number(currencies[iIndex].percent_change_24h);
                            percent_change_7d = Number(currencies[iIndex].percent_change_7d);
                            last_updated = Number(currencies[iIndex].last_updated);
                            oParsingCurrency = {
                                id: id,
                                name: name,
                                symbol: symbol,
                                rank: rank,
                                price_usd: price_usd,
                                price_btc: price_btc,
                                volume_usd_24h: volume_usd_24h,
                                market_cap_usd: market_cap_usd,
                                available_supply: available_supply,
                                total_supply: total_supply,
                                max_supply: max_supply,
                                percent_change_1h: percent_change_1h,
                                percent_change_24h: percent_change_24h,
                                percent_change_7d: percent_change_7d,
                                last_updated: last_updated
                            };
                            aReturnCurrencies.push(oParsingCurrency);
                        }
                        // has returned the data we expected
                        return [2 /*return*/, aReturnCurrencies];
                    }
                    return [2 /*return*/, null];
                case 2:
                    err_3 = _b.sent();
                    console.log(err_3);
                    return [2 /*return*/, null];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.getAllCryptoValues = getAllCryptoValues;
